--- eyeD3.orig	2013-12-24 20:28:09.013765827 +0100
+++ eyeD3	2013-12-24 20:37:14.569426681 +0100
@@ -259,6 +259,11 @@
    grp1.add_option("--remove-all", action="store_true",
                     dest="remove_all", default=0,
                     help="Remove both ID3 v1.x and v2.x tags.");
+   grp1.add_option("--pattern", action="store_true",
+                    dest="pattern", default=0,
+                    help="Treat the tag value given as a pattern using "\
+                         "substitution variables as with --rename, plus "\
+                         "%f for the filename (without directory or extension).");
    optParser.add_option_group(grp1);
 
    # Misc. options.
@@ -543,7 +548,7 @@
 
          # Handle frame edits.
          try:
-             tagModified = self.handleEdits(self.tag) or self.opts.force_update;
+             tagModified = self.handleEdits(self.tag,f) or self.opts.force_update;
          except CommandException, ex:
              printError(ex);
              return self.R_HALT;
@@ -610,7 +615,7 @@
 
       return status;
 
-   def handleEdits(self, tag):
+   def handleEdits(self, tag,f):
       retval = 0;
 
       # First set new version if requested
@@ -629,19 +634,19 @@
       artist = self.opts.artist;
       if artist != None:
          printWarning("Setting artist: %s" % artist);
-         tag.setArtist(artist);
+         tag.setArtist(self.fill(f,tag,artist));
          retval |= 1;
 
       album = self.opts.album;
       if album != None:
          printWarning("Setting album: %s" % album);
-         tag.setAlbum(album);
+         tag.setAlbum(self.fill(f,tag,album));
          retval |= 1;
 
       title = self.opts.title;
       if title != None:
          printWarning("Setting title: %s" % title);
-         tag.setTitle(title);
+         tag.setTitle(self.fill(f,tag,title));
          retval |= 1;
 
       discNum = self.opts.disc
@@ -679,13 +684,13 @@
       genre = self.opts.genre;
       if genre != None:
          printWarning("Setting track genre: %s" % genre);
-         tag.setGenre(genre);
+         tag.setGenre(self.fill(f,tag,genre));
          retval |= 1;
 
       year = self.opts.year;
       if year != None:
          printWarning("Setting year: %s" % year);
-         tag.setDate(year);
+         tag.setDate(self.fill(f,tag,year));
          retval |= 1;
 
       play_count = self.opts.play_count;
@@ -728,7 +733,7 @@
       pub = self.opts.publisher;
       if pub != None:
           printWarning("Setting publisher: %s" % (pub));
-          tag.setPublisher(pub);
+          tag.setPublisher(self.fill(f,tag,pub));
           retval |= 1;
 
       comments = self.opts.comments;
@@ -746,7 +751,7 @@
                    printWarning("Removing comment: %s" % (desc));
                else:
                    printWarning("Setting comment: [%s]: %s" % (desc, comm));
-               tag.addComment(comm, desc, lang);
+               tag.addComment(comm, self.fill(f,tag,desc), lang);
                retval |= 1;
             except ValueError:
                printError("Invalid Comment; see --help: %s" % c);
@@ -929,6 +934,16 @@
 
       return retval;
 
+   def fill(self,f,tag,pattern):
+ 
+       if (self.opts.pattern):
+          result = tag.tagToString(pattern);
+          result = tag._subst(result,"%f",unicode(os.path.splitext(os.path.basename(f))[0],
+                                           self.opts.fs_encoding,'replace'));
+       else:
+          result = pattern;
+       return result;  
+
    def handleRenames(self, f, pattern, fs_encoding):
        try:
            name = f.getTag().tagToString(pattern);
